#include <iostream>
using namespace std;

const int MAXN = 4000006;
const int MOD = 1000000007;

int n, l, r;
int fact[MAXN], inv_fact[MAXN];

void Init()
{
    cin >> n >> l >> r;
    fact[0] = inv_fact[0] = 1;
    for (int i = 1; i <= n; ++ i)
    {
        fact[i] = (1LL * fact[i - 1] * i) % MOD;
    }

    // find 1/(n!)
    int deg = 1, pow = fact[n], res = 1;
    while (deg <= MOD - 2)
    {
        if ((MOD - 2) & deg) res = (1LL * res * pow) % MOD;
        pow = (1LL * pow * pow) % MOD;
        deg *= 2;

    }  
    inv_fact[n] = res;
    
    for (int i = n - 1; i >= 1; -- i)
    {
        inv_fact[i] = (1LL * inv_fact[i + 1] * (i + 1)) % MOD;
    }
}

int comb(int n, int k)
{
    int tmp = (1LL * fact[n] * inv_fact[k]) % MOD;
    return (1ll * tmp * inv_fact[n - k]) % MOD;
}

int main()
{
    Init();

    long long ans = 0, der = 1, pm = 1;
    for (int i = 0; i <= n; ++ i)
    {
        if (l <= n - i and n - i <= r) ans = (ans + der * comb(n, n - i)) % MOD;   
        pm *= -1;
        der = ((i + 1) * der + pm) % MOD; 

    }

    cout << ans << endl;
    return 0;
}